/* NiuTrans.Tensor - an open-source tensor library
 * Copyright (C) 2018, Natural Language Processing Lab, Northeastern University.
 * All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/*
 * $Created by: HU Chi (huchinlp@foxmail.com)
 */


#ifndef TRAINER_H_
#define TRAINER_H_

#include "SLTKModel.h"
#include "SLTKDataUtility.h"

using namespace nts;
using namespace std;
using namespace util;
namespace ner
{

struct Trainer
{
    Config *config;

    /* list of the moment of the parameter matrices */
    XList moments;

    /* list of the 2nd order moment of the parameter matrices */
    XList moments2nd;

    void Train(BiLSTMCRFModel *model) const;

    // void MakeCheckpoint(BiLSTMCRFModel * model, const char * label, int id);

    explicit Trainer(Config *cfg)
    {
        config = cfg;
    }

    /* prepare model for training */
    void PrepareModel(BiLSTMCRFModel * model);

};

void NERMain(int argc, const char **argv);

} // namespace ner

#endif // TRAINER_H_